/*
 Copyright (C) 2022 Ivan Polyakov

 This file is part of vilor's website.

 Vilor's website is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Vilor's website is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include "query.h"
#include "utils.h"
#include <string.h>
#include <stdio.h>

void read_params(char *query, struct param *params)
{
    struct param *param = NULL;

    query = strtok(query, PARAM_DEL);
    while (query) {
        if ((param = find_param_by_key(params, query))) {
            size_t valsz = 0;

            if (!(query = strtok(NULL, PARAM_DEL))) {
                break;
            }

            valsz = strlen(query) + 1;
            if (valsz <= MAX_PARAMVAL_SZ) {
                memcpy(param->val, query, valsz);
                strreplace(param->val, "%23", "#");
            }
        }

        query = strtok(NULL, PARAM_DEL);
    }
}

struct param *find_param_by_key(struct param *params, const char *key)
{
    int i = 0;

    while (params[i].key) {
        if (!strcmp(key, params[i].key)) {
            return &params[i];
        }

        i++;
    }

    return NULL;
}

void reset_params(struct param *params)
{
    int i = 0;
    while (params[i].key) {
        sprintf(params[i].val, "%s", params[i].defaultval);
        i++;
    }
}
