/*
 Copyright (C) 2022 Ivan Polyakov

 This file is part of vilor's website.

 Vilor's website is free software: you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation, either version 3 of the License, or
 (at your option) any later version.

 Vilor's website is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.

 You should have received a copy of the GNU General Public License
 along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
#include "routes.h"
#include "server.h"
#include "template.h"
#include <string.h>
#include <stdio.h>

int res_scrollbar(struct route *route, FCGX_Request *req, const char **buff)
{
    char fpath[ROUTESZ];

    sprintf(fpath, "%s%s", STATIC_PATH, route->uri);

    reset_params(route->params);
    read_params(FCGX_GetParam("QUERY_STRING", req->envp), route->params);

    if (rendertpl(fpath, buff, route->params)) {
        return 1;
    }

    return 0;
}

struct route *find_route(FCGX_Request *request)
{
    char buff[ROUTESZ], *uri;
    int i = 0;

    uri = FCGX_GetParam("REQUEST_URI", request->envp);

    while (routes[i].uri) {
        size_t routelen, urilen;

        routelen = strlen(routes[i].uri);
        urilen   = strlen(uri);

        if (urilen < routelen) {
            continue;
        }

        memcpy(buff, uri, routelen);
        buff[routelen] = '\0';

        if (!strcmp(buff, routes[i].uri)) {
            return &routes[i];
        }

        i++;
    }

    return NULL;
}
