;; Copyright (C) 2022 Ivan Polyakov
;;
;; This file is part of vilor's website.
;;
;; Vilor's website is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; Vilor's website is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>.

(define header-links
  '(("/" "Home")
    ("/webapps/index.html" "Web Apps")
    ("http://git.vilor.one/vilor/" "Git")
    ("/contacts.html" "Contacts")))

(define header
  `(header (@ (class "header"))
        (div (@ (class "container"))
             (h4 (@ (class "header__logo")) "vilor")
             (nav (@ (class "header__nav"))
                   ,(let ((idx -1))
                      (map (lambda (l)
                             (set! idx (+ idx 1))
                             `(,(if (> idx 0) '(" | ") '())
                               (a (@ (href ,(car l))) ,(cdr l))))
                           header-links))))))

'()
