// @license magnet:?xt=urn:btih:1f739d935676111cfff4b4693e3816e664797050&dn=gpl-3.0.txt GPL-v3-or-Later
/*
   Copyright (C) 2022 Ivan Polyakov
   This file is part of vilor's website.
   Vilor's website is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   Vilor's website is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */
import './style.scss';

(function() {
    var scssOut = document.getElementById("sbScssOut");
    scssOut.style = "display:none";

    var buttons = document.getElementById("sbBtns");
    createScssOutToggles(buttons);

    new ColorInput(
        document.getElementById("thumbclr"),
        document.getElementById("thumbclrtxt"));

    new ColorInput(
        document.getElementById("thumbbclr"),
        document.getElementById("thumbbclrtxt"));

    new ColorInput(
        document.getElementById("trackclr"),
        document.getElementById("trackclrtxt"));

    function ColorInput(tcolor, ttext) {
        tcolor.onchange = function() {
            ttext.value = tcolor.value;
        }

        ttext.onchange = function() {
            tcolor.value = ttext.value;
        }
    }

    function createScssOutToggles(root) {
        var printBtn = document.createElement("button");
        printBtn.type = "button";
        printBtn.textContent = "show scss";
        printBtn.onclick = function() {
            scssOut.style = "";
        };

        var clearBtn = document.createElement("button");
        clearBtn.type = "button";
        clearBtn.textContent = "hide scss";
        clearBtn.onclick = function() {
            scssOut.style = "display:none";
        };

        buttons.appendChild(printBtn);
        buttons.appendChild(clearBtn);

        return [printBtn, clearBtn];
    }
})();
