;; Copyright (C) 2022 Ivan Polyakov
;;
;; This file is part of vilor's website.
;;
;; Vilor's website is free software: you can redistribute it and/or modify
;; it under the terms of the GNU General Public License as published by
;; the Free Software Foundation, either version 3 of the License, or
;; (at your option) any later version.
;;
;; Vilor's website is distributed in the hope that it will be useful,
;; but WITHOUT ANY WARRANTY; without even the implied warranty of
;; MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;; GNU General Public License for more details.
;;
;; You should have received a copy of the GNU General Public License
;; along with this program.  If not, see <https://www.gnu.org/licenses/>.

;;(import scss)


(define* (clean-tpl
          page-title
          page-content

          #:optional
          (page-inline-style '())
          (page-scripts '())
          (page-meta '()))
  `(html (@ (lang "en"))
    (head
     (meta (@ (name "author") (content "Ivan Polyakov")))
     (meta (@ (name "viewport")
              (content "width=device-width, initial-scale=1")))

     (meta (@ (name "robots") (content "noindex,nofollow")))

     ,(map (lambda (args)
             `(meta ,(append '(@) args))) page-meta)

     (title ,page-title)

     ,(if (not (null? page-inline-style))
          `(link (@ (rel "stylesheet") (href ,page-inline-style)))
          '()))
    (body
     ,page-content

     ,(map
       (lambda (l)
         `(script (@ (src ,l) (type "text/javascript")) " "))
       page-scripts))))

'()
